% LU_differnetial_euqations_main Solves differential equation

clear all
close all

% parameters
g = 0.0189;
sg = 0.0150;
phi = 0.87;
gamma = 2.00;
delta = 0.89;
Sbar = 0.057;
h = 12; % horizon, then divided into nsteps

g = g/h;
sg = sg/h^0.5;
phi = phi^(1/h);
delta = delta^(1/h);
sbar = log(Sbar);
smax = sbar + 1/2*(1-Sbar^2);
Smax = exp(smax); 


c = [-0.15:0.01:0.15]';% final c
c = [c; [-0.01:0.001:0.01]'];
c = sortrows(c); 
Nc = size(c,1);
nstepsv = [1 30]';
X = ones(Nc,size(nstepsv,1));
sv = X;
C = exp(c);

for nstepi = 1:size(nstepsv,1);
    nsteps = nstepsv(nstepi);
    gn = g/nsteps;
    phin = phi^(1/nsteps);
    dcn = c/nsteps;
    s = sbar*ones(Nc,1); 
    for istep=1:nsteps;
        s = (1-phin)*sbar + phin*s + lambdaofs(s,sbar,smax).*(dcn-gn);
    end;
    % S = (C-X)/C  X = C-S*C = C(1-e(s))
    sv(:,nstepi) = s; 
    X(:,nstepi) = exp(c).*(1-exp(s));
end;

figure
plot(C,X(:,1),'-k','linewidth',2);
hold on
plot(C,X(:,2),'-r','linewidth',2);
plot(C,C,'linewidth',2);
text(1.14,0.7,' X, One Step','color','k');
text(C(end),X(end,2),' X, Continuous','color','r');
text(C(end),C(end),' C','color','b')
%plot([1-sg 1-sg]',[.5 1.5]', '-k');
%plot([1+sg 1+sg]',[.5 1.5]', '-k');
xlabel('C')
axis([0.85 1.25 0.6 1.3])
title('Consumption Growth and Contemporaneous Habit');
print -depsc2 uhlig_CX.eps

figure
plot(C,X(:,1),'-b','linewidth',2);
hold on
plot(C,X(:,2),'--r','linewidth',2);
xlabel('C')
ylabel('X')
plot(exp([g g]'),[.5 1.5]', '-k');
axis([0.99 1.01 0.944 0.9446])
legend('\Delta = 1 month','Continuous',2)
title('Consumption growth and contemporaneous habit');

figure
plot(100*log(C),100*log(X(:,1)),'-b','linewidth',2);
hold on
plot(100*log(C),100*log(X(:,2)),'--r','linewidth',2);
xlabel('\Delta c_t, percent')
ylabel('100 \times x_t')
plot(100*[g g]',[-5.8 -5.7]', '-k');
axis([-1 1 -5.8 -5.7])
text(-0.6,-5.77,'\Delta = 1 month','color','b');
text(-0.8,-5.715,'Continuous','color','r');
%legend('\Delta = 1 month','Continuous',2)
%title('Consumption growth and contemporaneous habit');
print -depsc2 uhlig_CX_small.eps

%print -depsc2 uhlig_CX_small.eps


%%%%%% do Daily for spc graph

h = 365; % horizon, then divided into nsteps
g = g/h;
sg = sg/h^0.5;
phi = phi^(1/h);
delta = delta^(1/h);
sbar = log(Sbar);
smax = sbar + 1/2*(1-Sbar^2);
Smax = exp(smax); 


c = [-0.15:0.01:0.15]';% final c
c = [c; [-0.01:0.001:0.01]'];
c = sortrows(c); 
Nc = size(c,1);
nstepsv = [1 300]';
X = ones(Nc,size(nstepsv,1));
sv = X;
C = exp(c);

for nstepi = 1:size(nstepsv,1);
    nsteps = nstepsv(nstepi);
    gn = g/nsteps;
    phin = phi^(1/nsteps);
    dcn = c/nsteps;
    s = sbar*ones(Nc,1); 
    for istep=1:nsteps;
        s = (1-phin)*sbar + phin*s + lambdaofs(s,sbar,smax).*(dcn-gn);
    end;
    % S = (C-X)/C  X = C-S*C = C(1-e(s))
    sv(:,nstepi) = s; 
    X(:,nstepi) = exp(c).*(1-exp(s));
end;

figure
plot(log(C),sv(:,1),'-b','linewidth',2);
hold on
plot(log(C),sv(:,2),'--r','linewidth',2);
plot(log(C),smax+0*C,'--m');
plot([0 0],[-7 -1],'-k')
text(0.87-1,-4,'One Step','color','b');
text(0.9-1,smax,'s_{max}','color','m','backgroundcolor','w')
text(0.93-1,-5.6,'Continuous','color','r');
%legend('One-step','Continuous','s_{max}',2)
xlabel('Log consumption c');
ylabel('Log spc s');
axis([-0.15 0.1 -7 -1])
%title('Consumption and contemporaneous spc');
print -depsc2 uhlig_CS.eps


